/************************************************/
/*						*/
/*		small-c compiler		*/
/*						*/
/*		  by Ron Cain			*/
/*						*/
/************************************************/

#define BANNER  "* * *  Small-C  V1.1  * * *"

#define VERSION "CP/M Version N: July 17, 1980"

#define AUTHOR "       By Ron Cain"

/*	Define system dependent parameters	*/

/*	Stand-alone definitions			*/
#define NULL 0
#define eol 13

/*	UNIX definitions (if not stand-alone)	*/
/* #include <stdio.h>	*/
/* #define eol 10	*/

/*	Define the symbol table parameters	*/
#define	symsiz	14
#define	symtbsz	5040
#define numglbs 300
#define	startglb symtab
#define	endglb	startglb+numglbs*symsiz
#define	startloc endglb+symsiz
#define	endloc	symtab+symtbsz-symsiz

/*	Define symbol table entry format	*/
#define	name	0
#define	ident	9
#define	type	10
#define	storage	11
#define	offset	12

/*	System wide name size (for symbols)	*/
#define	namesize 9
#define namemax  8

/*	Define possible entries for "ident"	*/
#define	variable 1
#define	array	2
#define	pointer	3
#define	function 4

/*	Define possible entries for "type"	*/
#define	cchar	1
#define	cint	2

/*	Define possible entries for "storage"	*/
#define	statik	1
#define	stkloc	2

/*	Define the "while" statement queue	*/
#define	wqtabsz	100
#define	wqsiz	5
#define	wqmax	wq+wqtabsz-wqsiz

/*	Define entry offsets in while queue	*/
#define	wqsym	0
#define	wqsp	1
#define	wqloop	2
#define	wqlab	3
#define	wqlab2	4

/*	Define the literal pool			*/
#define	litabsz	1000
#define	litmax	litabsz-1

/*	Define the input line			*/
#define	linesize 80
#define	linemax	linesize-1
#define	mpmax	linemax

/*	Define the macro (define) pool		*/
#define	macqsize 1000
#define	macmax	macqsize-1

/*	Define statement types (tokens)		*/
#define	stif	1
#define	stwhile	2
#define	streturn 3
#define	stbreak	4
#define	stcont	5
#define	stasm	6
#define	stexp	7

/* Define how to carve up a name too long for the assembler */
#define asmpref	7
#define asmsuff	7


/*	Now reserve some storage words		*/
char	symtab[symtbsz];	/* symbol table */
char	*glbptr,*locptr;		/* ptrs to next entries */

int	wq[wqtabsz];		/* while queue */
int	*wqptr;			/* ptr to next entry */

char	litq[litabsz];		/* literal pool */
int	litptr;			/* ptr to next entry */

char	macq[macqsize];		/* macro string buffer */
int	macptr;			/* and its index */

char	line[linesize];		/* parsing buffer */
char	mline[linesize];	/* temp macro buffer */
int	lptr,mptr;		/* ptrs into each */

/*	Misc storage	*/
int	nxtlab,		/* next avail label # */
	litlab,		/* label # assigned to literal pool */
	Msp,		/* Maximum relative stk ptr */
	Zsp,		/* compiler relative stk ptr */
	argstk,		/* function arg sp */
	ncmp,		/* # open compound statements */
	errcnt,		/* # errors in compilation */
	errstop,	/* stop on error			gtf 7/17/80 */
	eof,		/* set non-zero on final input eof */
	input,		/* iob # for input file */
	output,		/* iob # for output file (if any) */
	input2,		/* iob # for "include" file */
	glbflag,	/* non-zero if internal globals */
	ctext,		/* non-zero to intermix c-source */
	cmode,		/* non-zero while parsing c-code */
			/* zero when passing assembly code */
	lastst,		/* last executed statement type */
	mainflg,	/* output is to be first asm file	gtf 4/9/80 */
	saveout,	/* holds output ptr when diverted to console	   */
			/*					gtf 7/16/80 */
	fnstart,	/* line# of start of current fn.	gtf 7/2/80 */
	lineno,		/* line# in current file		gtf 7/2/80 */
	infunc,		/* "inside function" flag		gtf 7/2/80 */
	savestart,	/* copy of fnstart "	"		gtf 7/16/80 */
	saveline,	/* copy of lineno  "	"		gtf 7/16/80 */
	saveinfn;	/* copy of infunc  "	"		gtf 7/16/80 */

char   *currfn,		/* ptr to symtab entry for current fn.	gtf 7/17/80 */
       *savecurr;	/* copy of currfn for #include		gtf 7/17/80 */
char	quote[2];	/* literal string for '"' */
char	*cptr;		/* work ptr to any char buffer */
int	*iptr;		/* work ptr to any int buffer */



/*	Get the remainder of the compiler	*/
#include C86N-0.C
#include C86N-1.C
#include C86N-2.C
#include C86N-3.C
#include C86N-4.C
#include C86N-5.C
#include C86N-6.C
#include C86N-7.C
#include C86N-8.C
#include C86N-9.C
